import scipy.sparse, scipy.sparse.linalg
import numpy as np
import os, codecs, cPickle, math, sys, pdb

"""

run jobs with 

for((i=0;i<10;i++)); do oarsub -nSL.$i "python compute_BOW_job.py $i 10"; done

merge with:

import numpy as np 
csrs = [np.load("data/doc_word_matrix_csr_%d.pickle" % i, "r") for i in range(10)]
import scipy.sparse
csr = scipy.sparse.vstack(csrs)

"""



fnames = list(os.popen("find proceedings_long/ -name *.txt -size +0", "r"))
fnames.sort()

print "processing %d documents" % len(fnames)

# to remove punctuation
mapping = {
    ord(','): 0x20,
    ord(':'): 0x20,
    ord('!'): 0x20,
    ord('?'): 0x20,
    ord('.'): 0x20,
    ord('['): 0x20,
    ord(']'): 0x20,
    ord('('): 0x20,
    ord(')'): 0x20,
    };

def isnumber(s): 
    try:
        float(s)
        return True
    except ValueError: 
        return False

rank = int(sys.argv[1])
nproc = int(sys.argv[2])

f0 = len(fnames) * rank / nproc
f1 = len(fnames) * (rank + 1) / nproc

print "processing fnames %d:%d" % (f0, f1)

fnames = fnames[f0:f1]

if True:
    # constuct the document-word matrix
    
    dictionary = cPickle.load(open("data/dictionary.pickle", "r"))
    
    # alpha order
    dictionary.sort()

    # mapping from dictionary to word number
    dictionary = dict([(word, no) for no, word in enumerate(dictionary)])
    
    # Dictionary Of Keys based sparse matrix
    doc_word_matrix = scipy.sparse.dok_matrix((len(fnames), len(dictionary)))
    print "filling matrix of size", doc_word_matrix.shape
    
    for fno, fname in enumerate(fnames):
        fname = fname[:-1]
        print fname, len(doc_word_matrix)
        for line in codecs.open(fname, encoding = "utf8"): 
          line = line.translate(mapping)

          for word in line.split(): 
              word = word.lower()
              if word not in dictionary: continue
              doc_word_matrix[(fno, dictionary[word])] += 1

    cPickle.dump(doc_word_matrix, open("data/doc_word_matrix_%d.pickle" % rank, "w"))

    # convert sparse matrix format to something more linear algebra compatible
    m_csr = scipy.sparse.csr_matrix(doc_word_matrix)
    cPickle.dump(m_csr, open("data/doc_word_matrix_csr_%d.pickle" % rank, "w"), 2)

